﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Text.RegularExpressions;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;

namespace DataValidation
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();
		   
		}

		private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			PwForm.ValidateItem();
		    MessageBox.Show(PwForm.IsItemValid ? "Login validé" : "Login non valide, corrigez svp.");
        }

    
	}
	
	public class LoginInfo : INotifyPropertyChanged
	{
		private string loginName;
		
		[Required()]
		[Display(Name="Login name:",Description="Votre login personnel.")]
		public string LoginName
		{
			get { return loginName; }
			set 
			{
				checkNull(value);
				loginName = value.Trim();
			    dochange("LoginName");
			}
		}
		
		
		private string email;
		
		[Required()]
		[Display(Name="e-mail:",Description="Adresse mail pour vous joindre.")]
		public string Email
		{
			get { return email; }
			set 
			{
				checkNull(value);
				checkMail(value);
				email = value.Trim();
                dochange("Email");
			}
		}
		
		private string password;
		
		[Required()]
		[Display(Name="Mot de passe:",Description="Votre mot de passe de connexion.")]
		public string Password
		{
			get { return password; }
			set 
			{
				checkNull(value);
				password = value.Trim();
                dochange("Password");
			}
		}
		
		private string passwordCheck;
		
		[Required()]
		[Display(Name="Contrôle:",Description="Retapez ici votre mot de passe.")]
		public string PasswordCheck
		{
			get { return passwordCheck; }
			set 
			{
				checkNull(value);
				passwordCheck = value.Trim();
				if (string.Compare(password,passwordCheck)!=0)
					throw new Exception("Les mots de passe diffèrent !");
                dochange("PasswordCheck");
			}
		}
		
		private void checkMail(string value)
		{
			string pattern = @"^(([^<>()[\]\\.,;:\s@\""]+" 
                        + @"(\.[^<>()[\]\\.,;:\s@\""]+)*)|(\"".+\""))@" 
                        + @"((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}" 
                        + @"\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+" 
                        + @"[a-zA-Z]{2,}))$";
                  Regex regMail = new Regex(pattern);
                 if (!regMail.IsMatch(value)) throw new Exception("E-mail non valide !");
		}
		
		private void checkNull(string value)
		{ 
			if (string.IsNullOrEmpty(value)) throw new Exception("Ne peut être vide !");
		}

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void dochange(string property)
        {
            if (PropertyChanged!=null) PropertyChanged(this,new PropertyChangedEventArgs(property));
        }

        #endregion
    }
	
}